/*
 * Copyright (c) 2020 Raspberry Pi (Trading) Ltd.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef _PICO_MEM_OPS_H
#define _PICO_MEM_OPS_H

#include "pico/types.h"

/** \file mem_ops.h
 *  \defgroup pico_mem_ops pico_mem_ops
 *
 * Provides optimized replacement implementations of the compiler built-in memcpy, memset and related functions:
 *
 * - memset, memcpy
 * - __aeabi_memset, __aeabi_memset4, __aeabi_memset8, __aeabi_memcpy, __aeabi_memcpy4, __aeabi_memcpy8
 *
 * This library does not provide any additional functions
 */
#endif